library ieee;
use ieee.std_logic_1164.all;

entity isync is
generic
(
  SYNC_STAGES : integer := 2
);
port
(
  clk : in std_logic;
  reset : in std_logic; 
  sin : in std_logic;
  sout : out std_logic
);
end isync;

architecture rtl of isync is

signal sreg : std_logic_vector(SYNC_STAGES-1 downto 0);

begin

sout <= sreg(sreg'left);

process(clk, reset)
begin
  if reset = '1' then
    sreg <= (others => '0');
  elsif rising_edge(clk) then
    sreg <= sreg(sreg'left-1 downto sreg'right) & sin;
  end if;
end process;

end rtl;