library ieee;
use ieee.std_logic_1164.all;

entity isync_slv is
generic
(
  SYNC_STAGES : integer;
  WIDTH : integer
);
port
(
  clk : in std_logic;
  reset : in std_logic; 
  sin : in std_logic_vector(WIDTH-1 downto 0);
  sout : out std_logic_vector(WIDTH-1 downto 0)
);
end;

architecture rtl of isync_slv is

type SLV_ARRAY_T is array(natural range <>) of std_logic_vector(WIDTH-1 downto 0);

signal sreg : SLV_ARRAY_T(SYNC_STAGES-1 downto 0);

begin

sout <= sreg(sreg'left);

process(clk, reset)
begin
  if reset = '1' then
    sreg <= (others => (others => '0'));
  elsif rising_edge(clk) then
    sreg <= sreg(sreg'left-1 downto sreg'right) & sin;
  end if;
end process;

end rtl;